package it.micegroup.gestioneferie.pianificazioneferie.assembler;

import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.linkTo;
import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.methodOn;
import org.springframework.hateoas.CollectionModel;
import org.springframework.hateoas.Link;
import org.springframework.stereotype.Component;

import it.micegroup.gestioneferie.libs.assembler.BaseModelAssembler;
import it.micegroup.gestioneferie.pianificazioneferie.controller.DmotivazioniAlertPfController;
import it.micegroup.gestioneferie.pianificazioneferie.dto.DmotivazioniAlertPfDto;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DmotivazioniAlertPf;

import it.micegroup.gestioneferie.pianificazioneferie.controller.DammtiPianiFerieController;

@Component
public class DmotivazioniAlertPfModelAssembler
		extends BaseModelAssembler<DmotivazioniAlertPf, DmotivazioniAlertPfDto, DmotivazioniAlertPfController> {

	@Override
	public DmotivazioniAlertPfDto toModel(DmotivazioniAlertPf dmotivazioniAlertPf) {
		DmotivazioniAlertPfDto dmotivazioniAlertPfDto = map(dmotivazioniAlertPf, DmotivazioniAlertPfDto.class,
				DmotivazioniAlertPfController.class);

		// SELF LINK
		Link selfLink = convert(
				linkTo(methodOn(DmotivazioniAlertPfController.class).getByObjectKey(dmotivazioniAlertPf.getObjectKey()))
						.withSelfRel());
		dmotivazioniAlertPfDto.add(selfLink);

		// PARENT LINKS

		// CHILDREN LINKS
		if (dmotivazioniAlertPf.getTheDammtiPianiFerie() != null) {
			Link dammtiPianiFerieLink = convert(linkTo(methodOn(DammtiPianiFerieController.class)
					.findByDmotivazioniAlertPf(dmotivazioniAlertPf.getObjectKey(), null))
							.withRel("theDammtiPianiFerie"));
			dmotivazioniAlertPfDto.add(dammtiPianiFerieLink);
		}

		// PARENTS LINKS FOR IMPORTED MS

		// CHILDREN LINKS FOR IMPORTED MS

		return dmotivazioniAlertPfDto;

	}

	@Override
	public CollectionModel<DmotivazioniAlertPfDto> toCollectionModel(Iterable<? extends DmotivazioniAlertPf> entities) {
		CollectionModel<DmotivazioniAlertPfDto> collectionEntities = super.toCollectionModel(entities);
		// collectionEntities.add(linkTo(methodOn(OrdineController.class).findPaginated(null,
		// null)).withSelfRel());

		return collectionEntities;
	}

}

